class Ball {
  PVector position;
  PVector velocity;
  float myMaxRadius;
  float r, m;
  ArrayList<Circle> theCircles;
  ArrayList<Link> linksConnected;
  boolean isDead=false;
  int nbCircles;
  int noiseFactor=100;//facteur de bruit qui fait bouger la balle autour de sa position
  int circleWidth=5;
  int circleWidthFactor=30;

  Ball(float x, float y, float r_, float maxRadius, int nbCircles_) {
    position = new PVector(x, y);
    velocity = new PVector(X, Y);
    myMaxRadius=maxRadius;
    r = r_;
    //TODO ajouter le fade in
    m = r*.1;
    nbCircles=nbCircles_;
    theCircles=new ArrayList<Circle>();
    linksConnected=new ArrayList<Link>();
    for (int i=0; i<nbCircles; i++)
    {
      addCircle((int)r+(10*i), 5);
    }
  }
  void update() {
    float sgn=random(1)-0.5;//On tire au sort le signe de la vibration
    velocity.x+=sgn*noise(velocity.x)*noiseFactor*0.01;
    sgn=random(1)-0.5;
    velocity.y+=sgn*noise(velocity.y)*noiseFactor*0.01;
    position.add(velocity);
    for (int i = theCircles.size()-1; i >= 0; i--) {
      Circle circle = theCircles.get(i);
      circle.update(position, (int)r+(circleWidthFactor*i), circleWidth);
      //envoyer les infos du cercle en osc.
    }
  }

  PVector getPosition()
  {
    return position;
  }
  float getRadius()
  {
    return r;
  }
  boolean checkIfDead()
  {
    return isDead;
  }
  void setRadius(float radius)
  {
    if (radius>myMaxRadius||radius<3)
    {
      isDead=true;
    }
    else 
    {
      r=radius;
    }
  }
  void addCircle(int radius, int circleWidth)
  {
    theCircles.add(new Circle(radius, circleWidth, position));
  }
  void display() {
    noStroke();
    for (int i = theCircles.size()-1; i >= 0; i--) 
    {
      Circle circle = theCircles.get(i);
      circle.display();
    }
    fill(204);
    ellipse(position.x, position.y, r*2, r*2);
  }
  void removeCircles()
  {
    for (int i = theCircles.size()-1; i >= 0; i--) 
    {
      theCircles.remove(i);
    }
  }
  void removeLinks()
  {
    for (int i = linksConnected.size()-1; i >= 0; i--) 
    {
      Link link=linksConnected.get(i);
      link.setIsDead(true);
      linksConnected.remove(i);
    }
  }
  void setCircleWidthFactor(int factor)
  {
    circleWidthFactor=factor;
  }
  void setCircleWidth(int factor)
  {
    circleWidth=factor;
  }
  void addConnectedLink(Link link)
  {
    linksConnected.add(link);
  }
  void destructor()
  {
    //TODO FADE OUT
    removeCircles();
    removeLinks();
  }
}

